=== modified file 'connection.cpp'
--- connection.cpp	2014-07-01 16:16:07 +0000
+++ connection.cpp	2014-07-23 20:49:49 +0000
@@ -264,6 +264,7 @@
     QObject::connect(mOfonoNetworkRegistration, SIGNAL(statusChanged(QString)), SLOT(onOfonoNetworkRegistrationChanged(QString)));
     QObject::connect(mOfonoMessageWaiting, SIGNAL(voicemailMessageCountChanged(int)), voicemailIface.data(), SLOT(setVoicemailCount(int)));
     QObject::connect(mOfonoMessageWaiting, SIGNAL(voicemailWaitingChanged(bool)), voicemailIface.data(), SLOT(setVoicemailIndicator(bool)));
+    QObject::connect(mOfonoMessageWaiting, SIGNAL(voicemailMailboxNumberChanged(QString)), voicemailIface.data(), SLOT(setVoicemailNumber(QString)));
 
     QObject::connect(mMmsdManager, SIGNAL(serviceAdded(const QString&)), SLOT(onMMSDServiceAdded(const QString&)));
     QObject::connect(mMmsdManager, SIGNAL(serviceRemoved(const QString&)), SLOT(onMMSDServiceRemoved(const QString&)));

=== modified file 'voicemailiface.cpp'
--- voicemailiface.cpp	2013-06-01 01:50:34 +0000
+++ voicemailiface.cpp	2014-07-23 20:49:49 +0000
@@ -122,6 +122,11 @@
     Q_EMIT mPriv->adaptee->voicemailCountChanged(uint(count));
 }
 
+void BaseConnectionVoicemailInterface::setVoicemailNumber(const QString &voicemailNumber)
+{
+    Q_EMIT mPriv->adaptee->voicemailNumberChanged(voicemailNumber);
+}
+
 void BaseConnectionVoicemailInterface::setVoicemailIndicator(bool active)
 {
     Q_EMIT mPriv->adaptee->voicemailIndicatorChanged(active);
@@ -145,6 +150,7 @@
 {
     connect(adaptee, SIGNAL(voicemailCountChanged(uint)), SIGNAL(VoicemailCountChanged(uint)));
     connect(adaptee, SIGNAL(voicemailIndicatorChanged(bool)), SIGNAL(VoicemailIndicatorChanged(bool)));
+    connect(adaptee, SIGNAL(voicemailNumberChanged(QString)), SIGNAL(VoicemailNumberChanged(QString)));
 }
 
 ConnectionInterfaceVoicemailAdaptor::~ConnectionInterfaceVoicemailAdaptor()

=== modified file 'voicemailiface.h'
--- voicemailiface.h	2013-06-01 01:50:34 +0000
+++ voicemailiface.h	2014-07-23 20:49:49 +0000
@@ -61,6 +61,7 @@
 public Q_SLOTS:
     void setVoicemailCount(int count);
     void setVoicemailIndicator(bool active);
+    void setVoicemailNumber(const QString &voicemailNumber);
 
 protected:
     BaseConnectionVoicemailInterface();
@@ -97,6 +98,9 @@
 "    <signal name=\"VoicemailIndicatorChanged\">\n"
 "      <arg type=\"b\" name=\"active\"/>\n"
 "    </signal>\n"
+"    <signal name=\"VoicemailNumberChanged\">\n"
+"      <arg type=\"s\" name=\"voicemailNumber\"/>\n"
+"    </signal>\n"
 "  </interface>\n"
 "")
 
@@ -116,6 +120,7 @@
 Q_SIGNALS: // SIGNALS
     void VoicemailCountChanged(uint count);
     void VoicemailIndicatorChanged(bool active);
+    void VoicemailNumberChanged(const QString &voicemailNumber);
 };
 
 
@@ -135,6 +140,7 @@
 Q_SIGNALS:
     void voicemailCountChanged(uint count);
     void voicemailIndicatorChanged(bool active);
+    void voicemailNumberChanged(const QString &voicemailNumber);
 
 public:
     BaseConnectionVoicemailInterface *mInterface;

